from classlib.track import *

        
class Diverge_curve(Track):

    def make_track(self):
        """
        This function sets essential parameters for the specific track
        element. It needs to be called once during initialization.
        """
        self.info= 'Diverge track element where one output section '+\
                   'is a circular curve.\n'+\
                   'Drag nodes to stretch input section or modify curve '+\
                   'radius.'
        
        entryline={'shape': ( 'line', {'offset':(0,0,0), 'length':50} ),
                   'car_max': 8,
                   'topo' : (1,2),
                   }
        
        straightbranch={'shape': ('line', {'offset':(50,0,0), 'length':50}),
                        'car_max': 5,
                        'topo' : (2,3),
                        }

        tobranch={'shape': ( 'curve', {'offset':(50,0,0),
                                       'radius':50,
                                       'turn'  :'right'
                                       }),
                  'car_max': 5,
                  'topo' : (2,4)
                  }
        
        self.element=[entryline,straightbranch,tobranch]
        self.nodes_connect={1:'in', 3:'out',4:'out'}
        # define Type of track element when different from standard SISO
        self.Mod=Divmod # module specialized for 1:N diverge operations
        
