from classlib.track import *



class Stop10berth_rightside(Stop):

    def make_track(self):
        """
        This function sets essential parameters for the specific track
        element. It needs to be called once during initialization.
        """
        
        
        self.element=[\
            # s0 entry
            {'label':'entry',
             'shape': ( 'line', {'offset':(0.0,0.0,0.0),
                                 'length':5.0} ),
             'topo' : (1,2),
             },
            # s1 main at entry
            {'label':'main_entry',
             'shape': ('line', {'offset':(5.0,0.0,0.0),
                                'length':20.0}),
             'topo' : (2,3),
             },
            # s4 main at exit
            {'label':'main_exit',
             'shape': ('line', {'offset':(25.0,0.0,0.0),
                                'length':100.0}),
             'topo' : (3,4),
             },
            # s4 exit
            {'label':'exit',
             'shape': ('line', {'offset':(125.0,0.0,0.0),
                                'length':5.0}),
             'topo' : (4,5),
             },
            # s5 brake-line
            {'label':'brake',
             'velocity_line': 3.0,
             'shape': ('scurve', {'offset':(5.0,0.0,0.0),
                                  'length':30.0,
                                  'displace':5.0,
                                  'turn'  :'right'
                                  }),
             'topo' : (2,6)
             },
            # s6 berths
            {'label':'berths',
             'type':'berth',
             'berth_length':3.8,
             'berth_no':    10,
             'berths_keep_clear': 4,
             'shape':         ('line', {'offset':(35.0,5.0,0),'length':60.0}),
             'velocity_line': 3.0,
             'topo' :         (6,7),
             },
            #s7 acceleration-line
            {'label':'accel',
             'shape': ('scurve', {'offset':(95.0,5.0,0.0),
                                  'length':30.0,
                                  'displace':5.0,
                                  'turn'  :'left'
                                  }),
             'topo' : (7,4)
             },
            ]

        self.nodes_connect={1:'in', 5:'out'}

        #self.info='Off-line stop with 3 berth and 60m of total length.\n'+\ 
        #'Main line velocity is 8.3m/s'
        self.info= 'Stop with 10 berths which are off-line, '+\
                   'on the right side.\n'+\
                   'Default main line velocity is 8.3m/s\n '+\
                   'DO NOT EXCEED THIS VELOCITY !'+\
                   'Both nodes can be dragged in order to change the length.'
        
        # define class for this track element module
        self.Mod=Stopmod

    
