from classlib.track import *



class Stop3berth_rightside(Stop):

    def make_track(self):
        """
        This function sets essential parameters for the specific track
        element. It needs to be called once during initialization.
        """
        
        self.element=[\
            # s0 entry
            {'label':'entry',
             'shape': ( 'line', {'offset':(0.0,0.0,0.0),
                                 'length':5.0} ),
             'topo' : (1,2),
             },
            # s1 main at entry
            {'label':'main_entry',
             'shape': ('line', {'offset':(5.0,0.0,0.0),
                                'length':20.0}),
             'topo' : (2,3),
             },
            # s4 main at exit
            {'label':'main_exit',
             'shape': ('line', {'offset':(25.0,0.0,0.0),
                                'length':55.0}),
             'topo' : (3,4),
             },
            # s4 exit
            {'label':'exit',
             'shape': ('line', {'offset':(80.0,0.0,0.0),
                                'length':5.0}),
             'topo' : (4,5),
             },
            # s5 brake-line
            {'label':'brake',
             'velocity_line': 3.0,
             'shape': ('scurve', {'offset':(5.0,5.0,0.0),
                                  'length':30.0,
                                  'displace':-5.0,
                                  'turn'  :'right'
                                  }),
             'topo' : (2,6),
             },
            # s6 berths
            {'label':'berths',
             'type':'berth',
             'berth_no':    3,
             'berth_length':3.8,
             'berths_keep_clear': 1,
             'shape':         ('line', {'offset':(35.0,5.0,0),'length':15.0}),
             'velocity_line': 3.0,
             'topo' :         (6,7),
             },
            #s7 acceleration-line
            {'label':'accel',
             'shape': ('scurve', {'offset':(50.0,0.0,0.0),
                                  'length':30.0,
                                  'displace':-5.0,
                                  'turn'  :'left'
                                  }),
             'topo' : (7,4),
             },
            ]

        self.nodes_connect={1:'in', 5:'out'}


        self.info= 'Stop with 3 off-line berths'+\
                   'on the right side.'+\
                   'Use in low traffic density areas \n'+\
                   'because optimized for low space usage \n'+\
                   'The stop is designed for a main line velocity of '+\
                   '8.3 m/s.'+\
                   'DO NOT EXCEED THIS VELOCITY !'+\
                   'Both extremities can be extended by dragging the nodes.'
        
        # define class for this track element module
        self.Mod=Stopmod

 
